/* comet v2.3.1 */
/* DO NOT EDIT: The contents of this file are dynamically generated and will be overwritten */


var Comet = Comet || {};

Comet.GlobalNavBar = function() {
    'use strict';
    var moreNavVisibleClass = "comet-global-nav-bar--more-nav-expanded",
        globalNavBarCustomizationEnabledClass = "comet-page-shell--global-nav-bar-customizing";


    function setActiveState($globalNav) {
        var filename = /[^/]*$/.exec(window.location.pathname)[0];
        $globalNav.find("a[href$='" + filename + "']").closest(".comet-global-nav-bar__item").addClass("comet-global-nav-bar__item--selected comet-list-group__row--selected");
    }

    function setEventListeners($globalNav) {
        $globalNav.on("click", ".js-comet-global-nav-bar__more-nav-trigger", function(e){
            e.preventDefault();
            if ($globalNav.hasClass(moreNavVisibleClass)) {
                $globalNav.removeClass(moreNavVisibleClass);
            } else {
                $globalNav.addClass(moreNavVisibleClass);
            }
        });

        $globalNav.on("click", ".js-comet-global-nav-bar__customization-toggle", function(e){
            e.preventDefault();
            toggleCustomizationMode();
        });

        $globalNav.on("click", ".js-comet-global-nav-bar__reset-menu", function(e){
            e.preventDefault();
            // Trigger the confirmation modal
            toggleCustomizationMode();
        });

        $globalNav.on("click", ".js-comet-global-nav-bar__save-nav-order", function(e){
            e.preventDefault();
            // Save current nav order for user
            toggleCustomizationMode();
        });

        $globalNav.on("click", ".js-comet-global-nav-bar__cancel-nav-order", function(e){
            e.preventDefault();
            // Revert back to nav order from the start of customization mode
            toggleCustomizationMode();
        });

        $globalNav.on("mouseleave", function(e){
            $(document).trigger("comet-collapse-global-nav-bar");
        });

        $(document).on("click", "." + globalNavBarCustomizationEnabledClass + " .comet-global-nav-bar__link", function(e){
            e.preventDefault(); // Prevent nav links from functioning when customization mode is active
        });
    }

    function toggleCustomizationMode() {
        $(document).trigger("comet-toggle-global-nav-bar-customization-mode");
        toggleSortableHandles();
    }

    function navSortStart($globalNav) {
        $(document).trigger("comet-global-nav-bar-sort-start");
    }

    function navSortStop($globalNav) {
        $(document).trigger("comet-global-nav-bar-sort-end");
        $globalNav.find(".comet-global-nav-bar__item").removeAttr("style");
        // This is where the new nav order would be saved to some persistent data layer
    }

    function toggleSortableHandles() {
        // Check for presence of class on page shell, but doesn't add or remove the class, that's the page shell's responsibility
        if ($(".comet-page-shell").hasClass(globalNavBarCustomizationEnabledClass)) {
            // Allow entire nav item to be draggable target
            enableSortableBehavior($(".comet-global-nav-bar"), false);
        } else {
            // Only allow reordering if the grip handle is clicked directly
            enableSortableBehavior($(".comet-global-nav-bar"), true);
        }
    }

    function enableSortableBehavior($globalNav, gripHandlesOnly) {
        var gripHandlesOnly = typeof gripHandlesOnly === 'undefined' ? true : gripHandlesOnly,
            sortableOptions = {
                "axis": "y",
                "containment": ".js-comet-global-nav-bar",
                "cursor": "grabbing",
                "connectWith": ".js-comet-global-nav-bar__items--sortable",
                "handle": ".comet-global-nav-bar__customize-sortable-target",
                "items": ".comet-global-nav-bar__item--draggable",
                "placeholder": "comet-global-nav-bar__item-sort-placeholder",
                "start": function(event, ui) {
                    ui.item.addClass("comet-global-nav-bar__item--sorting");
                    navSortStart($globalNav);
                },
                "stop": function(event, ui) {
                    ui.item.removeClass("comet-global-nav-bar__item--sorting");
                    navSortStop($globalNav);
                }
            },
            moreHiddenDropzoneOptions = sortableOptions;

        if (gripHandlesOnly) {
            sortableOptions.handle = ".comet-global-nav-bar__item-grip-wrap";
        }

        $globalNav.find(".ui-sortable").each(function(){
            // Unbind the sortable so it can be recreated
            $(this).sortable("destroy");
        });


        $globalNav.find(".js-comet-global-nav-bar__items--more").sortable(sortableOptions);
        $globalNav.find(".js-comet-global-nav-bar__items--primary").sortable(sortableOptions);

        // If items are moved to the "More Products & Services" dropzone when "More Products & Services" is collapsed, then append the dropped item to the end of the "More Products & Services" list
        moreHiddenDropzoneOptions.receive = function(event, ui) {
            ui.item.appendTo($(".js-comet-global-nav-bar__items--more"));
        };
        $globalNav.find(".js-comet-global-nav-bar__items--more-hidden-dropzone").sortable(moreHiddenDropzoneOptions);
    }

    var init = function init() {
        $(".js-comet-global-nav-bar").each(function(){
            setActiveState($(this));
            setEventListeners($(this));
            enableSortableBehavior($(this));
        });
    };

    var publicVars = {
        'init': init
    };

    return publicVars;
}();


$(document).ready(function(){
    'use strict';
    Comet.GlobalNavBar.init();
});

var Comet = Comet || {};
// Deds namespace is deprecated but references Comet for backwards compatibility
var Deds = Comet;

Comet.GlobalNav = function() {
    'use strict';

    function set_active_state($global_nav) {
        $global_nav.find("a[href='" + window.location.pathname + "']").closest(".comet-list-group__row").addClass("comet-list-group__row--selected");
    }

    function set_event_listeners($global_nav) {
        $global_nav.find(".js-comet-global-nav-close-trigger").on("click", function(e){
            e.preventDefault();
            $("body").removeClass("comet-global-nav--visible");
        });
    }

    var init = function init() {
        $(".js-comet-global-nav").each(function(){
            set_active_state($(this));
            set_event_listeners($(this));
        });
    };

    var public_vars = {
        'init': init
    };

    return public_vars;
}();


$(document).ready(function(){
    'use strict';
    Comet.GlobalNav.init();
});

var Comet = Comet || {};

Comet.PageShell = function() {
    'use strict';
        var globalNavBarVisibleClass = "comet-page-shell--global-nav-bar-visible",
            globalNavBarExpandedClass = "comet-page-shell--global-nav-bar-expanded",
            panelVisibleClass = "comet-page-shell--panel-visible",
            globalNavBarSortingClass = "comet-page-shell--global-nav-bar-sorting",
            globalNavBarCustomizationEnabledClass = "comet-page-shell--global-nav-bar-customizing";

    function showGlobalNavBar() {
        $(".comet-page-shell").addClass(globalNavBarVisibleClass);
    }

    function hideGlobalNavBar() {
        $(".comet-page-shell").removeClass(globalNavBarVisibleClass);
    }

    function togglePanel() {
        if ($(".comet-page-shell").hasClass(panelVisibleClass)) {
            hidePanel();
        } else {
            showPanel();
        }
    }

    function showPanel() {
        $(".comet-page-shell").addClass(panelVisibleClass);
    }

    function hidePanel() {
        $(".comet-page-shell").removeClass(panelVisibleClass);
    }

    function expandGlobalNavBar() {
        if (!$(".comet-page-shell").hasClass(globalNavBarExpandedClass)) {
            $(".comet-page-shell").addClass(globalNavBarExpandedClass);
        }
    }

    function collapseGlobalNavBar() {
        // Don't collapse the global nav bar if it's being sorted
        if ($(".comet-page-shell").hasClass(globalNavBarExpandedClass) && !$(".comet-page-shell").hasClass(globalNavBarSortingClass)) {
            $(".comet-page-shell").removeClass(globalNavBarExpandedClass);
        }
    }

    function toggleGlobalNavBarCustomizationMode() {
        if ($(".comet-page-shell").hasClass(globalNavBarCustomizationEnabledClass)) {
            $(".comet-page-shell").removeClass(globalNavBarCustomizationEnabledClass);
        } else {
            $(".comet-page-shell").addClass(globalNavBarCustomizationEnabledClass);
        }
    }

    function enableGlobalNavBarSortingMode() {
        $(".comet-page-shell").addClass(globalNavBarSortingClass); // Add a class so the nav isn't collapsed during sorting
    }

    function disableGlobalNavBarSortingMode() {
        $(".comet-page-shell").removeClass(globalNavBarSortingClass); // Remove class so the nav will collapse as normal
    }

    function setEventListeners() {
        $(document).on("comet-show-global-nav-bar", showGlobalNavBar);

        $(document).on("comet-product-bar-toggle-panel", togglePanel);

        $(document).on("comet-global-nav-bar-sort-start", enableGlobalNavBarSortingMode);

        $(document).on("comet-global-nav-bar-sort-end", disableGlobalNavBarSortingMode);

        $(document).on("comet-toggle-global-nav-bar-customization-mode", toggleGlobalNavBarCustomizationMode);

        $(document).on("comet-expand-global-nav-bar", expandGlobalNavBar);

        $(document).on("comet-collapse-global-nav-bar", collapseGlobalNavBar);

        $(document).on("touchend", "." + globalNavBarExpandedClass + " .comet-page-shell__product-well", function(e){
            e.preventDefault();
            e.stopPropagation();
            collapseGlobalNavBar();
        });

        $(".comet-page-shell__global-nav-bar-touch-overlay").on("mouseenter", expandGlobalNavBar);

        $(".js-comet-page-shell__global-nav-bar").on("mouseleave", collapseGlobalNavBar);

        $(".comet-page-shell__global-nav-bar-touch-overlay").on("touchend", function(e){
            e.preventDefault();
            e.stopPropagation();
            expandGlobalNavBar();
        });

        $(".js-comet-page-shell__close-global-nav-bar").on("click", function(e){
            e.preventDefault();
            hideGlobalNavBar();
        });

        $(".js-comet-page-shell__product-well-overlay").on("click", function(e){
            e.preventDefault();
            if ($("." + globalNavBarCustomizationEnabledClass).length === 0) { // If "customize" mode isn't enabled allow clicks on the overlay to close the global nav
                hideGlobalNavBar();
            }
        });

        $(".js-comet-page-shell__close-panel").on("click", function(e){
            e.preventDefault();
            hidePanel();
        });
    }

    var init = function init() {
        setEventListeners();
    };

    var publicVars = {
        'init': init
    };

    return publicVars;
}();


$(document).ready(function(){
    'use strict';
    Comet.PageShell.init();
});

Comet.Popovers = function() {

    "use strict";

    var el;
    var $el;
    var isTooltip;
    var elTitle;
    var debouncedEls = [];  // debounce variable case of click then focus
    var nubSideLength = 12;
    var nubSpacing = 0; // space between nub and target element in px
    var nubEdgeOffset = 6; //distace offset from the edge of the tooltip
    var nubBaseLength = nubSideLength * Math.sqrt(2);
    var nubHeight = nubBaseLength / 2;
    var defaultTooltipPlacement = "top"; // default to comet-tooltip--top if no placement is specified
    var defaultPopoverPlacement = "bottom"; // default to comet-popover--bottom if no placement is specified

    var myHorizontal;  // horizontal alignment of tooltip with target element
    var myVertical;  // vertical alignment of tooltip with target element
    var atHorizontal; // horizontal position on target element tooltip is aligned with
    var atVertical; // vertical position on target element tooltip is aligned with

    var directions = ["top", "right", "bottom", "left"];

    var initialize = function(event, initializeTooltips) {
        // TODO: fix multiple initializations
        deactivateExistingPopovers(initializeTooltips);

        if (initializeTooltips) {
            // initialize tooltips only
            $('.js-comet-tooltip-trigger, *[data-comet-tooltip-text]').on("mouseenter mouseleave", triggerPopoverEvent);

            // initialize tooltips to display on load
            $('.js-comet-tooltip-trigger.js-comet-tooltip-trigger--on-load, *[data-comet-tooltip-text].js-comet-tooltip-trigger--on-load').trigger("mouseenter");
        } else {
            // initialize general popovers only
            $('.js-comet-popover-trigger').each(function() {
                var isHover = $(this).data("comet-popover-event") === "hover";
                var events = isHover ? "mouseenter mouseleave" : "click focus";
                $(this).on(events, triggerPopoverEvent);
            });

            $('.comet-popover').on("show hide", handlePopoverTrigger);
            $('.js-comet-tooltip-trigger, *[data-comet-tooltip-text]').on("show hide", ".comet-tooltip__content", handlePopoverTrigger);
        }

        listenForClickAway();
        listenForEscKeyPress();
    };

    var deactivateExistingPopovers = function(initializeTooltips) {
        if (initializeTooltips) {
            $('.js-comet-tooltip-trigger, *[data-comet-tooltip-text]').off("mouseenter mouseleave"); //remove listeners if already initialized
            $('.comet-tooltip__content').remove();
        } else {
            $('.js-comet-popover-trigger').off();
        }
    };

    var triggerPopoverEvent = function(event) {
        event.stopPropagation();
        var $popover;

        isTooltip = !!$(this).data("comet-tooltip-text");
        var debounce = event.type !== "mouseenter";

        var eventOpts = {
            "el": event.currentTarget,
            "debounce": debounce
        };

        if (isTooltip && (event.type === "mouseenter" || event.type === "mouseleave")) {
            positionTargetElement(this);

            if (!tooltipHasBeenRendered(this)) {
                renderTooltip(this);
            }

            $popover = $(this).find('.comet-tooltip__content');
        } else {
            var popoverId = $(this).data("comet-popover");
            $popover = $('#' + popoverId);
            // hide any tooltips
            $(this).find('.comet-tooltip__content').trigger("hide", eventOpts);
        }

        if (popoverIsVisible($popover)) {
            if (isTooltip && event.type === "mouseenter") {
                return;  //tooltips should never hide on mouseenter
            }
            $popover.trigger("hide", eventOpts);
        } else {
            if (isTooltip && event.type === "mouseleave") {
                return;  //tooltips should never show on mouseleave
            }
            $popover.trigger("show", eventOpts);
        }
    };

    var handlePopoverTrigger = function(event, opts) {
        opts = opts || {};
        el = opts.el || el;
        $el = $(el);
        var debounce = opts.debounce === void 0 ? true : opts.debounce;

        setTimeout(function() {
            debouncedEls = [];
        }, 200);

        if (debouncedEls.indexOf(this) === -1) {
            // prevent this element from accepting show and hide events for 200ms
            // this allows both focus and click events to fire and the show event
            // the tooltip is shown but not hidden
            if (debounce) {
                debouncedEls.push(this);
            }

            var $popover = $(this);

            if (event.type === "hide") {
                hidePopover($popover);
            } else if (event.type === "show") {
                showPopover($popover);
            }
        }
    };

    var popoverIsVisible = function($popover) {
        return $popover.hasClass("visible");
    };

    var listenForClickAway = function() {
        $(document).on("click", function(event) {
            if (!isPopover(event.target)) {
                closeAllPopups();
            }
        });
    };

    var listenForEscKeyPress = function() {
        $(document).on("keyup", function(event) {
            var escKeyCode = 27;
            if (event.which === escKeyCode) {
                closeAllPopups();
            }
        });
    };

    var closeAllPopups = function() {
        $('.comet-popover').trigger("hide");
    };

    var isPopover = function(clickedEl) {
        return isOrHasParent(clickedEl, "comet-popover");
    };

    var isOrHasParent = function(clickedEl, className) {
        var selector = "." + className;
        return $(clickedEl).hasClass(className) || !!$(clickedEl).closest(selector).length;
    };

    var showPopover = function($popover) {
        if (!isTooltip) {
            // hide any showing popovers
            $('.comet-popover, .comet-tooltip__content').not($popover).trigger("hide");
        }

        removeTitleAttr(); // prevent native browser tooltip

        el.offsetHeight; //Forces a redraw so the tooltip is added in its invisible state before the "visible" class is added
        $popover.addClass("visible");

        var positionInfo = getPositionInfo($popover);
        positionPopover($popover, positionInfo);
    };

    var removeTitleAttr = function() {
        elTitle = "";
        elTitle = $el.attr("title");

        if (elTitle) {
            $el.attr("title", "");
        }
    };

    var hidePopover = function($popover) {
        $popover.removeClass("visible");
        addTitleAttr(); // add title back for accessibility
    };

    var addTitleAttr = function() {
        if (elTitle) {
            $el.attr("title", elTitle);
        }
    };

    var positionTargetElement = function(targetEl) {
        if ($(targetEl).css("position") === "static") {  // only position if element is not already positioned
            $(targetEl).css("position", "relative");
        }
    };

    var tooltipHasBeenRendered = function(targetEl) {
        return !!$(targetEl).find('.comet-tooltip__content').length;
    };

    var renderTooltip = function(targetEl) {

        $(targetEl).append('<div class="comet-tooltip__content"><span class="comet-tooltip__nub"></span><span class="comet-tooltip__text">' + $(targetEl).data("comet-tooltip-text") + '</span></div>');
    };

    var getPositionInfo = function($popover) {

        var placement = getPlacement($popover);

        if (!placement) {

            var defaultClass = isTooltip ? "comet-tooltip--" + defaultTooltipPlacement : "comet-popover--" + defaultPopoverPlacement;
            $(getPlacedEl($popover)).addClass(defaultClass);
            placement = isTooltip ? defaultTooltipPlacement : defaultPopoverPlacement;
        }

        var tooltipOffset = nubHeight + nubSpacing; //shift to account for nub and spacing

        if (isVertical(placement)) {
            // the tooltip is above or below the target element
            myHorizontal = "center";
            atHorizontal = "center";
            myVertical = flipDirection(placement) + buildOffsetString(placement, tooltipOffset);
            atVertical = placement;
        } else {
            // tooltip is to the left or right of target element
            myVertical = "center";
            atVertical = "center";
            myHorizontal = flipDirection(placement) + buildOffsetString(placement, tooltipOffset);
            atHorizontal = placement;
        }

        var tooltipShiftDirection = getTooltipShiftDirection($popover);

        if (tooltipShiftDirection) {
            var myAlignment = flipDirection(tooltipShiftDirection);

            var nubPlacementShift = nubEdgeOffset + nubBaseLength / 2;
            myAlignment = myAlignment + buildOffsetString(myAlignment, nubPlacementShift);

            if (isVertical(tooltipShiftDirection)) {
                myVertical = myAlignment;
            } else {
                myHorizontal = myAlignment;
            }
        }

        // position using jQuery UI's position() function
        return {
            "my": myHorizontal + " " + myVertical,
            "at": atHorizontal + " " + atVertical,
            "of": $el,
            "using": setFinalPosition
        };
    };

    var getPlacement = function($popover) {
        var placement;

        directions.forEach(function(direction) {
            var pattern = new RegExp("comet-.*--" + direction);
            if (pattern.test(getPlacedEl($popover).className)) {
                placement = direction;
            }
        });

        return placement || null; // if no placement is specified, default to top
    };

    var getPlacedEl = function($popover) {
        // return the element that contains the positioning class
        return isTooltip ? el : $popover.get(0);
    };

    var isVertical = function(direction) {
        return direction === "top" || direction === "bottom";
    };

    var flipDirection = function(direction) {
        var directionOpposites = {
            "top": "bottom",
            "bottom": "top",
            "left": "right",
            "right": "left"
        };

        return directionOpposites[direction];
    };

    var buildOffsetString = function(direction, tooltipOffset) {
        //create string to set distance between tooltip and target element to  i.e. "top-20"

        var operator;

        if (direction === "top" || direction === "left") {
            operator = "-";
        } else {
            operator = "+";
        }

        return operator + tooltipOffset;
    };

    var getTooltipShiftDirection = function($popover) {
        var shiftDirection;

        directions.forEach(function(direction) {
            var pattern = new RegExp("comet-(tooltip|popover)--.+-" + direction);
            if (pattern.test(getPlacedEl($popover).className)) {
                shiftDirection = direction;
            }
        });

        return shiftDirection || null;
    };

    var positionPopover = function($popover, positionInfo) {
        // HACK: must call position twice for <span> and <a> elements
        $popover.position(positionInfo).position(positionInfo);
    };

    var setFinalPosition = function(position, info) {
        $(this).find(".comet-popover__nub , .comet-tooltip__nub").toggleClass("flipped", isFlipped(info));

        // have to set final position manually because of position's using() callback
        $(this).css(position);
    };

    var isFlipped = function(info) {
        // find placement of tooltip relative to target element and see if it matches intended placement
        var tooltipVerticalPlacement = flipDirection(info.vertical);
        var tooltipHorizontalPlacement = flipDirection(info.horizontal);
        return myVertical.indexOf(tooltipVerticalPlacement) > -1 || myHorizontal.indexOf(tooltipHorizontalPlacement) > -1;
    };

    // initialize tooltips by default when DOM content has loaded
    $(document).ready(initialize);

    return {
        "initialize": initialize
    };
}();


var Comet = Comet || {};

Comet.ProductBar = function() {
    'use strict';
    var legacyProductBarClass = 'comet-product-bar--legacy';

    function setEventListeners($productBar) {
        $productBar.find(".js-comet-product-bar__show-global-nav-bar").on("click", function(e){
            // If it's a legacy product bar, just function as a link, don't trigger any global nav, it doesn't exist in this case
            if (!$productBar.hasClass(legacyProductBarClass)) {
                e.preventDefault();
                $(document).trigger("comet-show-global-nav-bar");
            }
        });

        $productBar.find(".js-comet-product-bar__toggle-panel").on("click", function(e){
            e.preventDefault();
            $(document).trigger("comet-product-bar-toggle-panel");
        });
    }

    var init = function init() {
        $(".js-comet-product-bar").each(function(){
            setEventListeners($(this));
        });
    };

    var publicVars = {
        'init': init
    };

    return publicVars;
}();


$(document).ready(function(){
    'use strict';
    Comet.ProductBar.init();
});

Comet.Tooltips = function() {

    "use strict";

    var initialize = function() {
        Comet.Popovers.initialize({}, true);
    };

    // initialize tooltips by default when DOM content has loaded
    $(document).ready(initialize);

    return {
        "initialize": initialize
    };
}();


var Comet = Comet || {};

Comet.TopHat = function() {
    'use strict';

    var set_event_listeners = function() {
        $(".js-comet-top-hat__close-button").on("click", function(e){
            e.preventDefault();
            hide_top_hat(e);
        });
    };

    var hide_top_hat = function(e) {
        var $topHat = $(e.target).closest(".comet-top-hat"),
            $topHatHeight = $topHat.outerHeight();

        $topHat.addClass("comet-top-hat--hidden");
        $topHat.attr("aria-hidden", true);
        $topHat.css("margin-top", "-" + $topHatHeight);
    };

    var initialize = function initialize() {
        set_event_listeners();
    };

    var public_vars = {
        'initialize': initialize
    };

    return public_vars;
}();

$(document).ready(function() {
    "use strict";

    Comet.TopHat.initialize();
});
